<?php

namespace cosolis\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailableImagesDetail StructType
 * @package Cosolis
 * @subpackage Structs
 */
class CosolisAvailableImagesDetail extends AbstractStructBase
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Size
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Size;
    /**
     * Constructor method for AvailableImagesDetail
     * @uses CosolisAvailableImagesDetail::setType()
     * @uses CosolisAvailableImagesDetail::setSize()
     * @param string $type
     * @param string $size
     */
    public function __construct($type = null, $size = null)
    {
        $this
            ->setType($type)
            ->setSize($size);
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \cosolis\EnumType\CosolisAvailableImageType::valueIsValid()
     * @uses \cosolis\EnumType\CosolisAvailableImageType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \cosolis\StructType\CosolisAvailableImagesDetail
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\cosolis\EnumType\CosolisAvailableImageType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \cosolis\EnumType\CosolisAvailableImageType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \cosolis\EnumType\CosolisAvailableImageType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Size value
     * @return string|null
     */
    public function getSize()
    {
        return $this->Size;
    }
    /**
     * Set Size value
     * @uses \cosolis\EnumType\CosolisImageSizeType::valueIsValid()
     * @uses \cosolis\EnumType\CosolisImageSizeType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $size
     * @return \cosolis\StructType\CosolisAvailableImagesDetail
     */
    public function setSize($size = null)
    {
        // validation for constraint: enumeration
        if (!\cosolis\EnumType\CosolisImageSizeType::valueIsValid($size)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \cosolis\EnumType\CosolisImageSizeType', is_array($size) ? implode(', ', $size) : var_export($size, true), implode(', ', \cosolis\EnumType\CosolisImageSizeType::getValidValues())), __LINE__);
        }
        $this->Size = $size;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \cosolis\StructType\CosolisAvailableImagesDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
