<?php

namespace cosolis\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactAndAddress StructType
 * @package Cosolis
 * @subpackage Structs
 */
class CosolisContactAndAddress extends AbstractStructBase
{
    /**
     * The Contact
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \cosolis\StructType\CosolisContact
     */
    public $Contact;
    /**
     * The Address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \cosolis\StructType\CosolisAddress
     */
    public $Address;
    /**
     * Constructor method for ContactAndAddress
     * @uses CosolisContactAndAddress::setContact()
     * @uses CosolisContactAndAddress::setAddress()
     * @param \cosolis\StructType\CosolisContact $contact
     * @param \cosolis\StructType\CosolisAddress $address
     */
    public function __construct(\cosolis\StructType\CosolisContact $contact = null, \cosolis\StructType\CosolisAddress $address = null)
    {
        $this
            ->setContact($contact)
            ->setAddress($address);
    }
    /**
     * Get Contact value
     * @return \cosolis\StructType\CosolisContact
     */
    public function getContact()
    {
        return $this->Contact;
    }
    /**
     * Set Contact value
     * @param \cosolis\StructType\CosolisContact $contact
     * @return \cosolis\StructType\CosolisContactAndAddress
     */
    public function setContact(\cosolis\StructType\CosolisContact $contact = null)
    {
        $this->Contact = $contact;
        return $this;
    }
    /**
     * Get Address value
     * @return \cosolis\StructType\CosolisAddress|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \cosolis\StructType\CosolisAddress $address
     * @return \cosolis\StructType\CosolisContactAndAddress
     */
    public function setAddress(\cosolis\StructType\CosolisAddress $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \cosolis\StructType\CosolisContactAndAddress
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
