<?php

namespace cosolis\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TrackingDateOrTimestamp StructType
 * @package Cosolis
 * @subpackage Structs
 */
class CosolisTrackingDateOrTimestamp extends AbstractStructBase
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The DateOrTimestamp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DateOrTimestamp;
    /**
     * Constructor method for TrackingDateOrTimestamp
     * @uses CosolisTrackingDateOrTimestamp::setType()
     * @uses CosolisTrackingDateOrTimestamp::setDateOrTimestamp()
     * @param string $type
     * @param string $dateOrTimestamp
     */
    public function __construct($type = null, $dateOrTimestamp = null)
    {
        $this
            ->setType($type)
            ->setDateOrTimestamp($dateOrTimestamp);
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \cosolis\EnumType\CosolisTrackingDateOrTimestampType::valueIsValid()
     * @uses \cosolis\EnumType\CosolisTrackingDateOrTimestampType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \cosolis\StructType\CosolisTrackingDateOrTimestamp
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\cosolis\EnumType\CosolisTrackingDateOrTimestampType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \cosolis\EnumType\CosolisTrackingDateOrTimestampType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \cosolis\EnumType\CosolisTrackingDateOrTimestampType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get DateOrTimestamp value
     * @return string|null
     */
    public function getDateOrTimestamp()
    {
        return $this->DateOrTimestamp;
    }
    /**
     * Set DateOrTimestamp value
     * @param string $dateOrTimestamp
     * @return \cosolis\StructType\CosolisTrackingDateOrTimestamp
     */
    public function setDateOrTimestamp($dateOrTimestamp = null)
    {
        // validation for constraint: string
        if (!is_null($dateOrTimestamp) && !is_string($dateOrTimestamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateOrTimestamp, true), gettype($dateOrTimestamp)), __LINE__);
        }
        $this->DateOrTimestamp = $dateOrTimestamp;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \cosolis\StructType\CosolisTrackingDateOrTimestamp
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
